package com.casic.dcms.view.statistics;

import android.content.Context;
import android.graphics.Color;
import android.os.Bundle;
import android.view.View;
import android.widget.RadioGroup;

import androidx.annotation.Nullable;
import androidx.lifecycle.Observer;
import androidx.lifecycle.ViewModelProvider;

import com.casic.dcms.R;
import com.casic.dcms.adapter.NormalRecyclerAdapter;
import com.casic.dcms.databinding.ActivityDeptHandleConditionBinding;
import com.casic.dcms.model.DeptHandleConditionBean;
import com.casic.dcms.utils.ChartViewHelper;
import com.casic.dcms.utils.ColorKit;
import com.casic.dcms.utils.LocaleConstant;
import com.casic.dcms.utils.TimeOrDateUtil;
import com.casic.dcms.utils.ViewGroupKit;
import com.casic.dcms.vm.DataAnalysisViewModel;
import com.casic.dcms.widgets.RangeDateActionSheet;
import com.github.mikephil.charting.data.BarEntry;
import com.pengxh.androidx.lite.adapter.ViewHolder;
import com.pengxh.androidx.lite.base.AndroidxBaseActivity;
import com.pengxh.androidx.lite.divider.RecyclerViewItemDivider;
import com.pengxh.androidx.lite.kit.LongKit;
import com.pengxh.androidx.lite.utils.LoadState;
import com.pengxh.androidx.lite.utils.LoadingDialog;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;

/**
 * @author a203
 * @package com.casic.dcms.ui
 * @date 2022/2/15 09:46
 * @email 290677893@qq.com
 */
public class DeptHandleConditionActivity extends AndroidxBaseActivity<ActivityDeptHandleConditionBinding> {

    private static final String TAG = "DeptHandleConditionActivity";
    private final Context context = DeptHandleConditionActivity.this;
    private DataAnalysisViewModel dataAnalysisViewModel;

    @Override
    protected void setupTopBarLayout() {
        ViewGroupKit.initImmersionBar(binding.rootView, this, true, R.color.white);

        binding.titleBarLayout.titleView.setText(LocaleConstant.ANALYSIS_ITEMS.get(3));
        binding.titleBarLayout.leftBackView.setOnClickListener(v -> finish());
    }

    @Override
    protected void observeRequestState() {
        dataAnalysisViewModel.loadState.observe(this, new Observer<LoadState>() {
            @Override
            public void onChanged(LoadState loadState) {
                if (loadState == LoadState.Loading) {
                    LoadingDialog.show(DeptHandleConditionActivity.this, "数据加载中，请稍后");
                } else {
                    LoadingDialog.dismiss();
                }
            }
        });
    }

    @Override
    protected void initOnCreate(@Nullable Bundle savedInstanceState) {
        dataAnalysisViewModel = new ViewModelProvider(this).get(DataAnalysisViewModel.class);
        dataAnalysisViewModel.deptHandleConditionModel.observe(this, new Observer<DeptHandleConditionBean>() {
            @Override
            public void onChanged(DeptHandleConditionBean conditionBean) {
                if (conditionBean.getCode() == 200) {
                    int caseCount = 0;
                    List<DeptHandleConditionBean.DataModel> dataModels = conditionBean.getData();
                    List<BarEntry> totalCheckBars = new ArrayList<>();//派发
                    List<BarEntry> checkBars = new ArrayList<>();//处置数
                    List<DeptHandleConditionBean.DataModel> effectiveModels = new ArrayList<>();
                    for (int i = 0; i < dataModels.size(); i++) {
                        DeptHandleConditionBean.DataModel dataModel = dataModels.get(i);
                        if (!dataModel.getDepartName().equals("合计")) {
                            effectiveModels.add(dataModel);

                            totalCheckBars.add(new BarEntry(i, Integer.parseInt(dataModel.getTotalCheckNum())));
                            checkBars.add(new BarEntry(i, Integer.parseInt(dataModel.getCheckedNum())));
                        } else {
                            caseCount = Integer.parseInt(dataModel.getTotalCheckNum());
                        }
                    }
                    binding.caseCountView.setText("案卷数：" + caseCount);

                    ChartViewHelper.setBarChartData(binding.horizontalBarChart, totalCheckBars, checkBars);

                    //按数量排序
                    Collections.sort(effectiveModels, new DeptHandleConditionComparator());

                    //绑定列表
                    NormalRecyclerAdapter<DeptHandleConditionBean.DataModel> recyclerAdapter = new NormalRecyclerAdapter<DeptHandleConditionBean.DataModel>(R.layout.item_case_dept_handle_lv_l, effectiveModels) {
                        @Override
                        public void convertView(ViewHolder viewHolder, int position, DeptHandleConditionBean.DataModel item) {
                            //设置随机颜色
                            int[] color = ColorKit.generateColor(context);

                            viewHolder.setText(R.id.numberTagView, String.valueOf(position + 1))
                                    .setBackgroundColor(R.id.numberTagView, color[0])
                                    .setTextColor(R.id.numberTagView, color[1])
                                    .setText(R.id.caseSourceView, item.getDepartName())
                                    .setText(R.id.caseTotalNumView, item.getTotalCheckNum())
                                    .setText(R.id.caseCheckedNumView, item.getCheckedNum());
                        }
                    };
                    binding.deptHandleView.addItemDecoration(new RecyclerViewItemDivider(1, Color.LTGRAY));
                    binding.deptHandleView.setAdapter(recyclerAdapter);
                }
            }
        });
    }

    @Override
    protected void onResume() {
        super.onResume();
        //默认加载当前时间往前一个月的
        dataAnalysisViewModel.getDeptHandleCondition(this, TimeOrDateUtil.getOneMonthDate(), LongKit.timestampToDate(System.currentTimeMillis()));
    }

    @Override
    protected void initEvent() {
        binding.selectCalendarButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                new RangeDateActionSheet.Builder().setContext(context).setOnActionSheetListener(new RangeDateActionSheet.OnDateRangeSelectedListener() {
                    @Override
                    public void onDateRangeSelected(String startDate, String endDate) {
                        dataAnalysisViewModel.getDeptHandleCondition(context, startDate, endDate);
                    }
                }).build().show();
            }
        });

        binding.radioGroup.setOnCheckedChangeListener(new RadioGroup.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(RadioGroup group, int checkedId) {
                if (checkedId == R.id.oneMonthRadioButton) {
                    dataAnalysisViewModel.getDeptHandleCondition(context, TimeOrDateUtil.getOneMonthDate(), LongKit.timestampToDate(System.currentTimeMillis()));
                } else if (checkedId == R.id.threeMonthRadioButton) {
                    dataAnalysisViewModel.getDeptHandleCondition(context, TimeOrDateUtil.getThreeMonthDate(), LongKit.timestampToDate(System.currentTimeMillis()));
                } else {
                    dataAnalysisViewModel.getDeptHandleCondition(context, TimeOrDateUtil.getSixMonthDate(), LongKit.timestampToDate(System.currentTimeMillis()));
                }
            }
        });
    }

    private static class DeptHandleConditionComparator implements Comparator<DeptHandleConditionBean.DataModel> {

        @Override
        public int compare(DeptHandleConditionBean.DataModel o1, DeptHandleConditionBean.DataModel o2) {
            int i = Integer.parseInt(o1.getTotalCheckNum());
            int j = Integer.parseInt(o2.getTotalCheckNum());
            return j - i;
        }
    }
}
